summaryrefslogtreecommitdiff
path: root/modules/blobs/print.sh
diff options
context:
space:
mode:
Diffstat (limited to 'modules/blobs/print.sh')
-rw-r--r--modules/blobs/print.sh41
1 files changed, 41 insertions, 0 deletions
diff --git a/modules/blobs/print.sh b/modules/blobs/print.sh
new file mode 100644
index 0000000..0e23adc
--- /dev/null
+++ b/modules/blobs/print.sh
@@ -0,0 +1,41 @@
+#!/usr/bin/env bash
+# rvs files/print - ???
+# Copyright (C) 2010, 2015 Luke Shumaker
+#
+# This file is part of rvs.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${0%/*}/_stdio.sh"
+
+usage='ID'
+[[ $# -eq 1 ]] || errusage
+id=$1
+
+hash="${id#*:}"
+file="$REPO/blobs/$hash"
+
+if [ -e "$file" ]; then
+ t="${id%%:*}"
+ type=''
+ case "$t" in
+ f) type='regular file';;
+ d) type='directory';;
+ l) type='link';;
+ esac
+ printf 'File Type: %s (%s)\n' "$t" "$type"
+else
+ fatal 'no object with ID `%s'\' "$id"
+fi
+